<div style="position:fixed;right: 10px;bottom:25px;z-index: 0;"><img src="<?php echo plugins_url( 'images/cyklodev.png' , dirname(__FILE__) );?>" width="100px" heigth="100px"/></div>
<?php

defined('ABSPATH') or die("Cannot access pages directly.");  

/*
 * Init twitter_api
 */

require_once(plugin_dir_path( dirname(__FILE__) ).'/lib/twitter_api.php');
$twitterApi = new TwitterApi();

/*
 * Get post ID 
 */

if(isset ($_GET['update_id'])){
    $post_data = get_post(intval($_GET['update_id']));
    
    echo "<hr /><h3>".esc_html__("Titre de l'article",'cyklodev-wp-notify')."</h3><center>".esc_html($post_data->post_title)."</center><hr />";
    
} else {
    echo '<br />' .
    wp_kses("Notifiez vos utilisateurs par role directement sur vos <a href='edit.php'>posts</a> ou directement dans le post.",'cyklodev-wp-notify') 
    . '<br />' .
    wp_kses("Pour utiliser les notifications Twitter configurez vos <a href='admin.php?page=cyklodev_notify_twitter'>paramètres</a>.",'cyklodev-wp-notify');
    return false;
}


if(isset($_GET['twitter']) && $_GET['twitter'] == 'twitting'){
 
    $options_list = array (
        'cyklodev_notify_twitter_consumer_secret'          => 'Twitter consumer secret',
        'cyklodev_notify_twitter_consumer_key'             => 'Twitter consumer key',
        'cyklodev_notify_twitter_access_token'             => 'Twitter access token',
        'cyklodev_notify_twitter_access_token_secret'      => 'Twitter access token secret'
    );
    
    $twitter_settings_complete = 1;
    foreach ($options_list as $k => $v) {
        if(get_option($k) == ''){
            $twitter_settings_complete = 0;
        }
    }
    


    if($twitter_settings_complete == 1 ){
         
        if(! $twitterApi->isOauth()){
            esc_html__("Extension php-pecl-oauth inactive !!!",'cyklodev-wp-notify');
            return false;
        }

        $oauth = [
            'consumer_key'          => get_option(sanitize_text_field('cyklodev_notify_twitter_consumer_key')),
            'consumer_secret'       => get_option(sanitize_text_field('cyklodev_notify_twitter_consumer_secret')),
            'token_key'             => get_option(sanitize_text_field('cyklodev_notify_twitter_access_token')),         
            'token_secret'          => get_option(sanitize_text_field('cyklodev_notify_twitter_access_token_secret')),   
        ];


        $twitterApi->get_signature(
            $oauth['consumer_key'],
            $oauth['consumer_secret'],
            $oauth['token_key'],
            $oauth['token_secret'],
            'POST');


        if(isset($_GET['tweet']) && $_GET['tweet'] == 'true'){
            echo '<h3>'.esc_html__("Notification Twitter",'cyklodev-wp-notify').'</h3>';

            $blogname = wp_specialchars_decode(get_option('blogname'), ENT_QUOTES);
            
            $formated_tweet = wp_kses_post($_POST['cyklodev_notify_tweet']);
            $formated_tweet = preg_replace( "/POST_TITLE/", esc_html($post_data->post_title), $formated_tweet );
            $formated_tweet = preg_replace( "/POST_URL/", get_permalink(intval($_GET['update_id'])), $formated_tweet );
            $formated_tweet = preg_replace( "/BLOG_NAME/", $blogname, $formated_tweet );
            
            var_dump($formated_tweet);

            $reply = $twitterApi->twitterPost($formated_tweet);
            

            switch (wp_remote_retrieve_response_code($reply)) {
                case 401:
                    echo '<div style="background-color:#ff0000;" align="center">Error : <b>'.wp_remote_retrieve_body($reply).'</b> Code ('.wp_remote_retrieve_response_code($reply).')
                      <br /> '.wp_kses("Verifiez  <a href='admin.php?page=cyklodev_notify_twitter'>vos clés twitter !</a>",'cyklodev-wp-notify').' 
                      </div>';
                    break;
                case 403:
                      echo '<div style="background-color:#ff0000;" align="center">Error : <b>'.wp_remote_retrieve_body($reply).'</b> Code ('.wp_remote_retrieve_response_code($reply).')
                      <br /> '.wp_kses("<a href='admin.php?page=cyklodev_notify&update_id=".esc_html($_GET['update_id'])."&twitter=twitting'>Go Back !</a>",'cyklodev-wp-notify').' 
                      </div>';
                    break;
                case 201:
                    echo '<div style="background-color:#00ff00;" align="center">'.__("Succès !",'cyklodev-wp-notify').'</div>';
                    break;               
                 default:
                    echo '<div style="background-color:#00ff00;" align="center">'.__("Oops http code [".wp_remote_retrieve_response_code($reply)."]",'cyklodev-wp-notify').'</div>';
                    break;
            }

            var_dump($reply);
        } else {
            if(get_bloginfo('language') == 'fr_FR'){
                $default_notify_tweet = "Un nouvel article est disponible sur #BLOG_NAME : POST_TITLE POST_URL";
             } else {
                $default_notify_tweet = "A new article is available on #BLOG_NAME : POST_TITLE POST_URL";
             }

            echo '
                  <h3>'.__("Customisez le tweet",'cyklodev-wp-notify').'</h3>
                <center>
                <form action="'.esc_html($_SERVER['PHP_SELF'])."?".esc_html($_SERVER['QUERY_STRING']).'&tweet=true" method="post">
                <input type="text" name="cyklodev_notify_tweet" id="cyklodev_notify_tweet" size="100" value="'.$default_notify_tweet.'">
                <input type="submit" value="'.esc_html__('Tweet it','cyklodev-wp-notify').'" class="button" />
                </form>
                <br /><b>Tips</b> : Metawords are POST_TITLE , POST_URL, BLOG_NAME </center>
                <hr/>';
        }
        
        
        return false;
    } else {
        echo wp_kses("Vous devez parametrer <a href='admin.php?page=cyklodev_notify_twitter'>vos clés twitter !</a>",'cyklodev-wp-notify');
        ($twitterApi->isOauth()) ? esc_html_e("Extension php-pecl-oauth est active",'cyklodev-wp-notify') :  esc_html_e("Extension php-pecl-oauth inactive !!!",'cyklodev-wp-notify');
        return false;
    }
}


/*
 * Get roles 
 */
    
global $wp_roles;
$roles = $wp_roles->get_names();


/*
 * Test submit button
 */


 if (isset($_POST)){

    foreach($_POST as $key => $value){
        foreach ($roles as $k => $v) {
            if($key == $k){
                $get_role_by_post = $key;
            }
        }   
    }
    
    
    foreach ($roles as $k => $v) {
        if (isset ($get_role_by_post) && $get_role_by_post == $k){
            esc_html_e('Notification envoyée aux ','cyklodev-wp-notify').$get_role_by_post;
            $blogusers = get_users('blog_id=1&orderby=nicename&role='.$k);
            $blogname = esc_html(get_option('blogname'), ENT_QUOTES);
            $headers[] = "From:  $blogname admin <".esc_html(get_option('admin_email')).">"; 
            
            foreach ($blogusers as $user) {
                echo '<li>' . esc_html($user->user_email) . '</li>';
                
                if(sanitize_text_field($_POST['cyklodev_notify_form']) == ''){
                    $message = __('Bonjour', 'cyklodev-wp-notify').' '.$user->user_login." \r\n\r\n";
                    $message .= __("Des nouveautés sur le site ont été publiées, l'article ", 'cyklodev-wp-notify').get_permalink(intval($_GET['update_id'])).__(' pourrait vous intéresser.','cyklodev-wp-notify')." \r\n\r\n";
                    $message .= __("N'hésitez pas à le commenter ! ", 'cyklodev-wp-notify')."\r\n\r\n";
                    $message .= __('A bientôt sur ', 'cyklodev-wp-notify').get_site_url()."\r\n";
                    $subject = __('Un nouvel article ', 'cyklodev-wp-notify').$post_data->post_title.__(' sur ','cyklodev-wp-notify').$blogname.__(' pourrait vous intéresser.','cyklodev-wp-notify');
                } else {
                    $message = wp_kses_post($_POST['cyklodev_notify_form']);
                    $message = preg_replace( "/USER_NAME/", esc_html($user->user_login), $message );
                    $message = preg_replace( "/POST_TITLE/", esc_html($post_data->post_title), $message );
                    $message = preg_replace( "/POST_URL/", get_permalink(intval($_GET['update_id'])), $message );
                    $message = preg_replace( "/BLOG_URL/", get_site_url(), $message );
                    $subject = wp_kses_post($_POST['cyklodev_notify_subject']);
                    $subject = preg_replace( "/POST_TITLE/", esc_html($post_data->post_title), $subject );
                    $subject = preg_replace( "/BLOG_NAME/", $blogname, $subject );
                    
                }
    
                wp_mail($user->user_email, $subject, esc_html($message),$headers); 
            }
            return false;
        }
    }
    
 }


/*
 *  Function count by role
 */

function get_count_of_users($role = '') {
    $result = count_users();
    if ($role == '') {
        return $result['total_users'];
    } else {
        foreach ($result['avail_roles'] as $roles => $count)
            if ($roles == $role) {
                return $count;
            }
    }
    return 0;
}

if(get_bloginfo('language') == 'fr_FR'){
    $default_notify_subject = "Un nouvel article est disponible sur BLOG_NAME : POST_TITLE";
    $default_notify_message = "
Bonjour USER_NAME,
Des nouveautés sur le site ont été publiées, l'article POST_TITLE pourrait vous intéresser.
POST_URL
N'hésitez pas à le commenter !
A bientôt sur BLOG_URL
    ";
 } else {
    $default_notify_subject = "A new article is available on BLOG_NAME : POST_TITLE";
    $default_notify_message = "
Hello USER_NAME,
A new article is out, POST_TITLE might interest you.
POST_URL
Please leave a comment !
See you soon on BLOG_URL
    ";
 }

/*
 * Create table
 */

echo '<form action="" method="post">';
echo '  <h3>'.__("Customisez le sujet",'cyklodev-wp-notify').'</h3>
        <center>
            <input type="text" name="cyklodev_notify_subject" id="cyklodev_notify_subject" size="80" value="'.esc_attr($default_notify_subject).'">
        <br /><b>Tips</b> : Metawords are POST_TITLE , BLOG_NAME </center>
        <hr/>';

echo '  <h3>'.__("Customisez le texte",'cyklodev-wp-notify').'</h3>
        <center><textarea name="cyklodev_notify_form" id="cyklodev_notify_form" rows="10" cols="80">';
        echo preg_replace( "/<br \/><br \/>/", "\n", esc_attr($default_notify_message) );  

        echo '</textarea>
        <br /><b>Tips</b> : Metawords are USER_NAME , POST_TITLE , POST_URL , BLOG_URL </center>
        <hr />
        <h3>'.__("Choissez le role",'cyklodev-wp-notify').'</h3>
        <table class="form-table" width="300px">';

foreach ($roles as $k => $v) {
    echo '
        <tr>
           <td>'.esc_attr($v).' ( '.  get_count_of_users($k).' )</td>
           <td>';
    if (get_count_of_users($k) > 0){
        echo '<input type="submit" name="'.esc_attr($k).'" value="'.esc_attr('Notifier','cyklodev-wp-notify').'" class="button"';
    }
    echo '</td> 
       </tr>

       ';
}
echo '</table></form>';
?>

