<?php

defined('ABSPATH') or die("Cannot access pages directly."); 

$options_list = array (
    'cyklodev_notify_twitter_consumer_secret'          => 'Twitter Api Key secret',
    'cyklodev_notify_twitter_consumer_key'             => 'Twitter Api Key',
    'cyklodev_notify_twitter_access_token'             => 'Twitter Access Token',
    'cyklodev_notify_twitter_access_token_secret'      => 'Twitter Access Token secret'
);

foreach ($options_list as $k => $v) {
    if (isset($_POST[$k])){  
        if(is_string($_POST[$k])){
            update_option($k,sanitize_text_field($_POST[$k]));
            echo '<div style="background-color:#00ff00;" align="center">Updated ! '.esc_html($v).'</div>';
        } else {
            echo '<div style="background-color:#ff0000;" align="center">Nice try but data not allowed !</div>';
        } 
    }
}

?>

<table class="form-table" width="300px">
<form action="" method="post">
<?php foreach ($options_list as $k => $v) {  ?> 
<tbody>
	<tr valign="top">

		<th scope="row"><label for="<?php echo esc_attr($k);?>"><?php echo esc_attr($v);?></label></th>
		<td>  
            <input type="text" name="<?php echo esc_attr($k);?>" value="<?php echo get_option(esc_attr($k)) ?>" size="60"/>
        </td>
	</tr>
</tbody>
<?php } ?>
</table>
<input type="submit" value="Update"/>
</form>
<div>
    <ul>
        <li>Create app <a href="https://developer.twitter.com/en/portal/dashboard"> Twitter Dev portal</a></li>
        <li>Edit User authentication settings to allow read AND WRITE</li>
        <li>Generate Consumer Keys (ApiKey&ApiSecret)</li>
        <li>Generate Access Token  (AccessToken&AccessTokenSecret)</li>
    </ul>
</div>
<div style="position:fixed;right: 10px;bottom:25px;z-index: 0;"><img src="<?php echo plugins_url( 'images/cyklodev.png' , dirname(__FILE__) );?>" width="100px" heigth="100px"/></div>
